import { VueConstructor } from 'vue';
import Btns from './btns';
import MyText from './myText';

interface Component {
  [prop: string]: unknown;
  install: (Vue: VueConstructor) => void;
}

// 存储组件列表
const components = [Btns, MyText];

const install: any = (Vue: VueConstructor) => {
  // 判断是否安装
  if (install.installed) return;
  // 遍历注册全局组件
  components.forEach((v: any) => Vue.component(v.name, v));
  // component.extendOptions.name
};

/* istanbul ignore if 判断是否是直接引入文件 */
if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

export default {
  install,
  // 以下是单个导出的组件。导出的对象必须具有 install，才能被 Vue.use() 方法安装
  Btns,
  MyText,
} as Component;
